% Yi, Shuang, and Yicong Zhou. "Separable and reversible data hiding in encrypted images using parametric binary tree labeling." 
% proposed in  IEEE Transactions on Multimedia 2018.
% Shuang Yi (yishuang0227@gmail.com);

clear all;close all; warning off; % clc;
prev_dir = pwd; file_dir = fileparts(mfilename('fullpath')); cd(file_dir); addpath(genpath(pwd));
file='airplane.pgm';  
im=double(imread(file));  %  lenna  baboon   peppers  airplane  barbara  boat
display(['==>' file]);
[M,N]=size(im);
[LL,LH,HL,HH]=NewEstimation(im);

er=1; q=7;
lengthData=er*M*N;


[empLH,length_data1]=DataHiding(LH,q,er);  [empHL,length_data2]=DataHiding(HL,q,er);
[empHH,length_data3]=DataHiding(HH,q,er);


ER=(length_data1+length_data2+length_data3)/(M*N);
display(['ER: ' num2str(ER) ' bpp']);

enD=ImageEncryption(LL,empLH,empHL,empHH, 100);
imshow(uint8(enD));
imwrite(uint8(enD),'enD.png');

reImg=iNewEstimation(LL,empLH,empHL,empHH);

figure;imshow(reImg,[]);
reImg=TrimImg(reImg);
imwrite(uint8(reImg),'reImg.png');

psnr=PSNR(im,reImg);
display(['PSNR: ' num2str(psnr) ]);
